/* Initialization code */
var BookmarksPreviewUtils = {
  location : null,
  contentDeck : null,
  selected : null,
  dir : null,
  bkmksTree : null,
  placesTree : null,
  _history : [],
  _historyIndex : 0,
  init : function(){
    try{
    var self = BookmarksPreviewUtils;
    BookmarksPreviewUtils.dir = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
    BookmarksPreviewUtils.dir.append("bookmarkPreviews");
    if (!BookmarksPreviewUtils.dir.exists())
      BookmarksPreviewUtils.dir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0777);

    self.placesTree = document.getElementById("bookmark-folders-view");
    var folderWidth = self.placesTree.getAttribute("width");
    /* since some lovely person decided, 'Hey, we don't need to include ids
      in order to make it easier for extension developers to overlay the
      bookmarks manager' these elements need to be added & positioned with
      javascript. Yay! */
    var vbox = document.createElement("vbox");
    vbox.setAttribute("id","defaultView");
    self.bkmksTree = document.getElementById("bookmarks-view");
    var bkmksWidth = self.bkmksTree.boxObject.width;//document.documentElement.boxObject.width - self.placesTree.width;//self.bkmksTree.boxObject.width
    var container = document.getElementById("albumview-container");
    container = container.parentNode.removeChild(container);
    vbox.appendChild(container);
    var splitter = document.createElement("splitter");
    var grippy = document.createElement("grippy");
    splitter.appendChild(grippy);
    splitter.setAttribute("id","albumview-splitter");
    splitter.setAttribute("collapse","before");
    splitter.setAttribute("resizeafter","closest");
    splitter.setAttribute("resizebefore","closest");
    vbox.appendChild(splitter);
    //collapse="before" resizeafter="closest"
    //            resizebefore="closest"
    //            insertafter="searchModifiers"
    var deck = document.createElement("deck");
    deck.setAttribute("id","contentDeck");
    deck.setAttribute("persist","width");
    deck.setAttribute("flex","4");
    deck.appendChild(vbox);
    self.bkmksTree.parentNode.insertBefore(deck,self.bkmksTree);
    self.bkmksTree.parentNode.removeChild(self.bkmksTree);
    vbox.appendChild(self.bkmksTree);

    self.bkmksTree.treeBuilder.addObserver(TreeObserver);
    //bmFolderView.treeBuilder.addObserver(TreeObserver);
    /* Listen to when ref changes instead of the left tree's select
      observer because we also want to be notified when a search has
      been performed
    */

    self.bkmksTree.addEventListener("DOMAttrModified",self.refModified,false);
    self.placesTree.setAttribute("width",folderWidth);
    //dump("previous deck: "+deck.boxObject.width+"\n");
    deck.setAttribute("width",bkmksWidth);
    //dump("new deck: "+deck.boxObject.width+"|"+bkmksWidth+"\n");
    /* create new menu items in the view menu */
    var nextElement = curElement = document.getElementById("view-separator");
    var insertbefore = document.getElementById("fill-after-this-node");
    var viewMenu = insertbefore.parentNode;
    var addItems = true;
    while(addItems){
      nextElement = curElement.nextSibling;
      addItems = curElement.id!="thumbsSize";
      viewMenu.insertBefore(curElement,insertbefore);
      curElement = nextElement;
    }

    /* Insert thumnail view in the correct spot */
    var thumbnailView = document.getElementById("thumbnailView");
    thumbnailView = thumbnailView.parentNode.removeChild(thumbnailView);
    deck.appendChild(thumbnailView);

    BookmarksPreviewUtils.contentDeck = deck;
    var detailsMenu = document.getElementById("detailsViewMenu");
    if (detailsMenu.getAttribute("checked"))
      BookmarksPreviewUtils.onSelectView('details');
    else{
      var thumbsMenu = detailsMenu.nextSibling;
      if (!thumbsMenu.getAttribute("checked"))
        BookmarksPreviewUtils.onSelectView('details');
      else
        BookmarksPreviewUtils.onSelectView('thumbnails');
    }
    }catch(e){Components.utils.reportError(e);}
    /* Move the info pane outside of the deck */
    //var contentView = BookmarksPreviewUtils.contentDeck.parentNode;
    //var infoSplitter = document.getElementById("contentSplitter");
    //var infoPane = document.getElementById("infoPane");
    //infoSplitter = infoSplitter.parentNode.removeChild(infoSplitter);
    //infoSplitter = contentView.appendChild(infoSplitter);
    //infoPane = infoPane.parentNode.removeChild(infoPane);
    //infoPane = contentView.appendChild(infoPane);
  },
  uninit : function(){
    var self = BookmarksPreviewUtils;
    self.bkmksTree.treeBuilder.removeObserver(TreeObserver);
    self.bkmksTree.removeEventListener("DOMAttrModified",self.refModified,false);
    if (ThumbView.initiated)
      ThumbView.uninit();
    if (AlbumView.initiated)
      AlbumView.uninit();
  },
  refModified : function(event){
    if (event.attrName=="ref" && event.target == BookmarksPreviewUtils.bkmksTree
        && !TreeObserver.utils.updatedSelection){
      dump("ref modified\n");
      TreeObserver.utils.refreshDisplay();
    }
  },
  onSelectView : function(type,event){
    dump("type: "+type+"\n");
    var self = BookmarksPreviewUtils;
    self.selected = type;
    if (type=="details"){
      if (!event || self.contentDeck.selectedIndex!=0){
        self.contentDeck.selectedIndex=0;
        if (ThumbView.initiated)
          ThumbView.uninit();
        AlbumViewUtils.initDisplay();
      }
    } else if (type=="thumbnails"){
      if (!event || self.contentDeck.selectedIndex!=1){
        self.contentDeck.selectedIndex=1;
        if (AlbumView.initiated)
          AlbumView.uninit();
        ThumbViewUtils.initDisplay();
      }
    }
  },
  getViewRoot : function(){
    var root;
    var curIndex = BookmarksPreviewUtils.bkmksTree.currentIndex;
    var rootIndex = -1;
    if (curIndex>-1 && BookmarksPreviewUtils.bkmksTree.tree.view.isContainer(curIndex))
      rootIndex = curIndex;
    else if (curIndex>-1)
      rootIndex = BookmarksPreviewUtils.bkmksTree.tree.view.getParentIndex(curIndex);;
    if (rootIndex>-1)
      root = BookmarksPreviewUtils.bkmksTree.getRowResource(rootIndex);
    else{
      root = BookmarksPreviewUtils.bkmksTree.getRootResource();

    }
    BookmarksPreviewUtils.addToBackHistory(root,"utils");
    dump("currentindex: "+curIndex+"|"+BookmarksPreviewUtils.bkmksTree.tree.currentIndex+"|"+BookmarksPreviewUtils.bkmksTree.tree.view.selection.currentIndex+"\n");
    dump("getviewroot: "+root.Value+"|"+rootIndex+"|"+curIndex+"\n");
    dump("root resource: "+BookmarksPreviewUtils.bkmksTree.getRootResource().Value+"|"+RDF.GetResource(BookmarksPreviewUtils.bkmksTree.tree.ref).Value+"\n");
    dump("name: "+BookmarksPreviewUtils.getResourceName(root)+"\n");
    return root;
  },
  getResourceName : function(resource){
    var nameProp = "http://home.netscape.com/NC-rdf#Name";
    var oldValue = BMDS.GetTarget(resource, RDF.GetResource(nameProp), true);
    if (oldValue)
      return oldValue.Value;
    else
      return null;
  },
  getBookmarkImages : function(bkmks,folder){
    if (!folder)
      folder = BookmarksPreviewUtils.getViewRoot();
    var nameProp = "http://home.netscape.com/NC-rdf#Name";
    var urlProp = "http://home.netscape.com/NC-rdf#URL";
    var bmProps = [RDF.GetResource(nameProp),
                        RDF.GetResource(urlProp)];
    var container = Components.classes[kRDFCContractID].createInstance(kRDFCIID);
    container.Init(BMDS, folder);
    var children = container.GetElements();
    while (children.hasMoreElements()){
      var child = children.getNext() ;
      if (child instanceof Components.interfaces.nsIRDFResource){
        var aType = BookmarksUtils.resolveType(child);
        if (aType!="BookmarkSeparator"){
          var childResource = child.QueryInterface(kRDFRSCIID);
          var props = [null, null];
          for (var j = 0; j < bmProps.length; ++j) {
             var oldValue = BMDS.GetTarget(childResource, bmProps[j], true);
             if (oldValue)
                props[j] = oldValue.QueryInterface(kRDFLITIID).Value;
          }
          var image = BookmarksPreviewUtils._getResourceImage(aType,props[1]);
          bkmks.push({image: image,
                      caption: props[0]?props[0]:props[1],
                      url: props[1],
                      node: childResource});
        }
      }
    }
  },
  _getResourceImage : function(aType,aURL){
    var nopreview = "chrome://bookmarkpreviews/skin/nopreview.png";
    var folderImage = "chrome://bookmarkpreviews/skin/folder.png";
    if (aType == "Livemark" || aType == "Folder" || aType=="PersonalToolbarFolder"){
      return folderImage;
    }
    if (!aURL){dump("nopreview: "+aType+"\n"); return nopreview;}
    var file = BookmarksPreviewUtils.dir.clone();
    file.append(encodeURIComponent(aURL.toLowerCase())+".jpg");
    if (file.exists() && file.isFile()){
      var contentType = Components.classes["@mozilla.org/mime;1"]
                              .getService(Components.interfaces.nsIMIMEService)
                              .getTypeFromFile(file);
      var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                                  .createInstance(Components.interfaces.nsIFileInputStream);
      inputStream.init(file, 0x01, 0600, 0);
      var stream = Components.classes["@mozilla.org/binaryinputstream;1"]
                             .createInstance(Components.interfaces.nsIBinaryInputStream);
      stream.setInputStream(inputStream);
      var encoded = btoa(stream.readBytes(stream.available()));
      return "data:" + contentType + ";base64," + encoded;
    }
    return nopreview;
  },
  addToBackHistory : function(resource,from){
    if (!this._history.some(function(ele,idx){
          return ele.Value == resource.Value;
        })){
      dump("addtobackhistory: "+resource.Value+" from: "+from+"|"+this._historyIndex+"|"+this._history.length+"\n");
      this._history.forEach(function(item,idx){
        dump(idx+") "+item.Value+"\n");
      });
      this._history.splice(0,this._historyIndex==0?0:this._historyIndex,resource);
      this._historyIndex = 0;

      dump("after insert\n");
      this._history.forEach(function(item,idx){
        dump(idx+") "+item.Value+"\n");
      });
    }
    this.updateNavigationStates();
  },
  back : function(event){
    dump("back\n");
    this.navigateHistory(1);
  },
  forward : function(event){
    this.navigateHistory(-1);
  },
  navigateHistory : function(direction){
    var location = this.getViewRoot();
    this._historyIndex+=direction;
    var historyEntry = this._history[this._historyIndex];
    TreeObserver.utils.updatedSelection = true;
    //var parent = BMDS.getParent(resource);
    if (historyEntry.Value=="NC:BookmarksTopRoot"){
      this.bkmksTree.tree.ref=historyEntry.Value;
      this.bkmksTree.tree.view.selection.clearSelection();
      this.bkmksTree.tree.view.selection.currentIndex=-1;
    }
    else{
      this.placesTree.tree.view.selection.clearSelection();
      this.placesTree.selectResource(historyEntry);
      var parent = BMDS.getParent(historyEntry);
      this.bkmksTree.tree.ref=parent.Value;
      this.bkmksTree.tree.view.selection.clearSelection();
      this.bkmksTree.selectResource(historyEntry);
    }
    TreeObserver.utils.updatedSelection = false;
    this.placesTree.treeBoxObject.ensureRowIsVisible(
      this.placesTree.treeBuilder.getIndexOfResource(historyEntry));
    dump("nav refresh display\n");
    TreeObserver.utils.refreshDisplay();
    dump("back: "+historyEntry.Value+"|"+this._historyIndex+"\n");
    this._history.forEach(function(item,idx){
      dump(idx+") "+item.Value+"\n");
    });
    dump("idx|length: "+this._historyIndex+"|"+this._history.length+"\n");
    this.updateNavigationStates();
  },
  updateNavigationStates : function(){
    var backbutton = document.getElementById("back-button");
    if (this._historyIndex==this._history.length-1 ){
      backbutton.setAttribute("disabled","true");
    }
    else
      backbutton.removeAttribute("disabled");
    var forwardbutton = document.getElementById("forward-button");
    if (this._historyIndex==0 ){
      forwardbutton.setAttribute("disabled","true");
    }
    else
      forwardbutton.removeAttribute("disabled");
  }
}
var AlbumViewUtils = {
  all : null,
  bkmksTree : null,
  tree : null,
  view : null,
  get bkmksTree(){
    return BookmarksPreviewUtils.bkmksTree;
  },
  initDisplay : function(){
    TreeObserver.utils = AlbumViewUtils;
    AlbumViewUtils.tree = BookmarksPreviewUtils.bkmksTree.tree;
    AlbumViewUtils.view = BookmarksPreviewUtils.bkmksTree.tree.view;
    AlbumView.init();
    setTimeout(AlbumViewUtils.refreshDisplay,0);
  },
  refreshDisplay : function(event){
    try{
      dump("refresh album display\n");
    var root;
    var curIndex = BookmarksPreviewUtils.bkmksTree.currentIndex;
    var rootIndex = -1;
    if (curIndex>-1 && BookmarksPreviewUtils.
            bkmksTree.tree.view.isContainerOpen(curIndex))
      rootIndex = curIndex;
    else if (curIndex>-1)
      rootIndex = BookmarksPreviewUtils.bkmksTree.tree.view.getParentIndex(curIndex);;
    if (rootIndex>-1)
      root = BookmarksPreviewUtils.bkmksTree.getRowResource(rootIndex);
    else{
      root = BookmarksPreviewUtils.bkmksTree.getRootResource();
      BookmarksPreviewUtils.addToBackHistory(root,"album");
    }
    if (root!=AlbumViewUtils.displayRoot){
      var bkmks=[]
      BookmarksPreviewUtils.getBookmarkImages(bkmks,root);
      AlbumView.createImages(bkmks);
      AlbumView.urrent = AlbumView.target = 0;
    }
    var nextTarget=AlbumViewUtils._getNextTarget(curIndex,rootIndex);
    //dump("nexttarget: "+nextTarget+"\n");
    AlbumViewUtils.displayRoot = root;
    AlbumView.keepFocus = false;
    AlbumView.refresh();
    //moveComplete();
    if (!(curIndex>-1 && AlbumViewUtils.view.isSeparator(curIndex)))
      AlbumView.glideTo(nextTarget*-150,false);
    }catch(e){
      Components.utils.reportError("AUTILS: "+e);
    }
  },
  _getNextTarget : function(cIndex,rIndex){
    if (cIndex>rIndex+1){
      var max = AlbumViewUtils.view.rowCount, level = AlbumViewUtils.view.getLevel(cIndex);
      var nextTarget = 0;//rIndex==-1?-1:0;
      for (var i = rIndex+1;i<cIndex;i++){
        if (AlbumViewUtils.view.getLevel(i)==level &&
           !AlbumViewUtils.view.isSeparator(i))
          nextTarget++;
      }
      return nextTarget;
    }
    return 0;
  },
  selectIndex : function(resource){
    if (AlbumView.keepFocus){
      AlbumViewUtils.updatedSelection = true;
      AlbumViewUtils.view.selection.clearSelection();
      AlbumViewUtils.bkmksTree.selectResource(resource);
      AlbumViewUtils.bkmksTree.treeBoxObject.ensureRowIsVisible(
          AlbumViewUtils.bkmksTree.treeBuilder.getIndexOfResource(resource));
      AlbumViewUtils.updatedSelection = false;
      //setTimeout(function(){AlbumViewUtils.container.focus();},0);
    }
    AlbumView.keepFocus = true;
  },
  performAction : function(resource,event){
    var aType = BookmarksUtils.resolveType(resource);
    if (aType == "Bookmark"){
      var target = BMDS.GetTarget(resource, RDF.GetResource("http://home.netscape.com/NC-rdf#URL"), true);
      target = target.QueryInterface(Components.interfaces.nsIRDFLiteral);
      if (target){
        var url = target.Value;
        openUILink(url,event);
      }
    }
    else if (aType == "Folder" || aType == "Livemark" || aType == "PersonalToolbarFolder"){
      AlbumViewUtils.bkmksTree.selectResource(resource);
      AlbumViewUtils.refreshDisplay();
    }
  }
}
var TreeObserver = {
  utils : null,
  canDrop : function(index, orientation){},
  onDrop : function(row, orientation){},
  onToggleOpenState  : function(index){
    //dump("toggleopenstate\n");
  },
  onCycleHeader : function(column){},
  onCycleCell : function(row, column){},
  onSelectionChanged : function(){
    //dump("selection changed - "+AlbumView.updatedSelection+" - \n");
    if (!TreeObserver.utils.updatedSelection)
      /*
      This listens to the detailed view and the folder view.
      Although the selection of the detailed view is updated in time when
      this is sent from the detailed view's tree, it isn't updated
      in time when it is sent from a selection change from the folder
      view
      */

      setTimeout(function(){
        dump("selection changed - tree observer\n");
        TreeObserver.utils.refreshDisplay();
      },5);
  },
  onPerformAction : function(action){},
  onPerformActionOnRow : function(action, row){},
  onPerformActionOnCell : function(action, row, column){}
}
var ThumbViewUtils = {
  displayRoot : null,
  displayView : null,
  view : null,
  initDisplay : function(){
    ThumbViewUtils.displayView = ThumbView;
    TreeObserver.utils = ThumbView.utils = ThumbViewUtils;
    ThumbView.init();
  },
  refreshDisplay : function(event){;
    var bkmks=[];
    dump("refresh thumb display\n");
    BookmarksPreviewUtils.getBookmarkImages(bkmks);
    //dump("refresh display loadimage: "+bkmks+"\n");
    ThumbView.loadImages(bkmks);
  },
  back : function(){/* Not implmented (FF3 only)*/},
  forward : function(){/* Not implmented (FF3 only)*/},
  getBookmarkImages : BookmarksPreviewUtils.getBookmarkImages,
  _getNextTarget : function(cIndex,rIndex){
    if (cIndex>rIndex+1){
      var max = ThumbViewUtils.view.rowCount, level = ThumbViewUtils.view.getLevel(cIndex);
      var nextTarget = 0;//rIndex==-1?-1:0;
      for (var i = rIndex+1;i<cIndex;i++){
        if (ThumbViewUtils.view.getLevel(i)==level &&
           !ThumbViewUtils.view.isSeparator(i))
          nextTarget++;
      }
      return nextTarget;
    }
    return 0;
  },
  selectItem : function(item, event){
    //ThumbViewUtils.updatedSelection = true;
    //BookmarksPreviewUtils.bkmksTree.tree.view.selection.clearSelection();
    //BookmarksPreviewUtils.bkmksTree.selectResource(item.node);
    //ThumbViewUtils.updatedSelection = false;
    return;
    if (gEditItemOverlay.itemId != -1) {
       var focusedElement = document.commandDispatcher.focusedElement;
       if ((focusedElement instanceof HTMLInputElement ||
            focusedElement instanceof HTMLTextAreaElement) &&
           /^editBMPanel.*/.test(focusedElement.parentNode.parentNode.id))
         focusedElement.blur();
     }

     var detailsDeck = document.getElementById("detailsDeck");
     if (item) {
       detailsDeck.selectedIndex = 1;
         var selectedNode = item.node;
         if (selectedNode.itemId != -1) {
           if (PlacesOrganizer._paneDisabled) {
             PlacesOrganizer._setDetailsFieldsDisabledState(false);
             PlacesOrganizer._paneDisabled = false;
           }

           gEditItemOverlay.initPanel(selectedNode.itemId,
                                      { hiddenRows: ["folderPicker"] });

           PlacesOrganizer._detectAndSetDetailsPaneMinimalState(selectedNode);
           return;
         }
     }
     else {
       detailsDeck.selectedIndex = 0;
       var selectItemDesc = document.getElementById("selectItemDescription");
       var itemsCountLabel = document.getElementById("itemsCountText");
       var rowCount = ThumbView.bookmarks.length;
       if (rowCount == 0) {
         selectItemDesc.hidden = true;
         itemsCountLabel.value = PlacesUtils.getString("detailsPane.noItems");
       }
       else {
         selectItemDesc.hidden = false;
         if (rowCount == 1)
           itemsCountLabel.value = PlacesUtils.getString("detailsPane.oneItem");
         else {
           itemsCountLabel.value =
             PlacesUtils.getFormattedString("detailsPane.multipleItems",
                                            [rowCount]);
         }
       }
     }

     // Nothing to do if the pane was already disabled
     if (!PlacesOrganizer._paneDisabled) {
       gEditItemOverlay.uninitPanel();
       PlacesOrganizer._setDetailsFieldsDisabledState(true);
       PlacesOrganizer._paneDisabled = true;
     }
  },
  performAction : function(item, event){
    var resource = item.node;
    var aType = BookmarksUtils.resolveType(resource);
    if (aType == "Bookmark"){
      var target = BMDS.GetTarget(resource, RDF.GetResource("http://home.netscape.com/NC-rdf#URL"), true);
      target = target.QueryInterface(Components.interfaces.nsIRDFLiteral);
      if (target){
        var url = target.Value;
        openUILink(url,event);
      }
    }
    else if (aType == "Folder" || aType == "Livemark" || aType == "PersonalToolbarFolder"){
      BookmarksPreviewUtils.bkmksTree.selectResource(resource);
    }
  },
  removeItem : function(item, event){
    var resource = item.node;
    var parent = BMDS.getParent(resource);
    var selection = BookmarksUtils.getSelectionFromResource(resource, parent);
    BookmarksCommand.deleteBookmark(selection);
    dump("remove item refresh display\n");
    ThumbViewUtils.refreshDisplay();
  },
  _getContextParent : function(){
    var target = document.popupNode;
    if (target && target.className == "thumbnail")
      return target;
    else if (target && target.tagName == "image")
      return target.parentNode;
    return null
  },
  createContextMenu : function(aEvent){
    dump("createcontextmenu\n");
    var self = ThumbViewUtils;
    var target = self._getContextParent();
    dump("createcontextmenu: "+target+"\n");
    if (!target) return false;

    var resource = ThumbView.selectedNode();
    var parent = BMDS.getParent(resource);
    var selection = BookmarksUtils.getSelectionFromResource(resource, parent);
    var target = BookmarksPreviewUtils.bkmksTree.getTreeTarget(resource,parent,BookmarksUtils.DROP_BEFORE);
    dump("tree sel: "+BookmarksPreviewUtils.bkmksTree._selection+"\n");
    //BookmarksPreviewUtils.bkmksTree._selection = selection;
    //BookmarksPreviewUtils.bkmksTree._target = target;

    //BookmarksCommand.createContextMenu(aEvent, selection);
    //self.onCommandUpdate();
    //BookmarksController.onCommandUpdate(selection, target);
    //tree.controllers.appendController(this.controller);


    return false;
  }
}
window.addEventListener('load',BookmarksPreviewUtils.init,false);
window.addEventListener('unload',BookmarksPreviewUtils.uninit,false);
