/* Initialization code */
var PlacesPreviewUtils = {
  contentDeck : null,
  selected : null,
  dir : null,
  init : function(){
    dump("preview init\n");
    PlacesPreviewUtils.dir = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
    PlacesPreviewUtils.dir.append("bookmarkPreviews");
    if (!PlacesPreviewUtils.dir.exists())
      PlacesPreviewUtils.dir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0777);

    PlacesOrganizer._content.getResultView().addViewObserver(TreeObserver,false);
    PlacesOrganizer._content.addEventListener("select",TreeObserver.onSelectionChanged,false);
    PlacesOrganizer._places.getResultView().addViewObserver(TreeObserver,false);
    //PlacesOrganizer._places.addEventListener("select",TreeObserver.onSelectionChanged,false);
    PlacesOrganizer._content.addEventListener("DOMAttrModified",PlacesPreviewUtils.placeModified,false);

    PlacesPreviewUtils.contentDeck = document.getElementById("contentDeck");
    var detailsMenu = document.getElementById("detailsViewMenu");
    if (detailsMenu.getAttribute("checked"))
      PlacesPreviewUtils.onSelectView('details');
    else
      PlacesPreviewUtils.onSelectView('thumbnails');
    /* Move the info pane outside of the deck */
    var contentView = PlacesPreviewUtils.contentDeck.parentNode;
    var infoSplitter = document.getElementById("contentSplitter");
    var infoPane = document.getElementById("infoPane");
    infoSplitter = infoSplitter.parentNode.removeChild(infoSplitter);
    infoSplitter = contentView.appendChild(infoSplitter);
    infoPane = infoPane.parentNode.removeChild(infoPane);
    infoPane = contentView.appendChild(infoPane);
  },
  uninit : function(){
    PlacesOrganizer._places.getResultView().removeViewObserver(TreeObserver,false);
    PlacesOrganizer._content.getResultView().removeViewObserver(TreeObserver,false);
    PlacesOrganizer._content.removeEventListener("select",TreeObserver.onSelectionChanged,false);
    PlacesOrganizer._content.removeEventListener("DOMAttrModified",PlacesPreviewUtils.placeModified,false);
    if (ThumbView.initiated)
      ThumbView.uninit();
    if (AlbumView.initiated)
      AlbumView.uninit();
  },
  placeModified : function(event){
    if (event.attrName == "place"){
      TreeObserver.onSelectionChanged(event);
    }
  },
  onSelectView : function(type,event){
    dump("type: "+type+"\n");
    var self = PlacesPreviewUtils;
    self.selected = type;
    if (type=="details"){
      if (!event || self.contentDeck.selectedIndex!=0){
        self.contentDeck.selectedIndex=0;
        if (ThumbView.initiated)
          ThumbView.uninit();
        AlbumViewUtils.initDisplay();
      }
    } else if (type=="thumbnails"){
      if (!event || self.contentDeck.selectedIndex!=1){
        self.contentDeck.selectedIndex=1;
        if (AlbumView.initiated)
          AlbumView.uninit();
        ThumbViewUtils.initDisplay();
      }
    }
  },
  getViewRoot : function(){
    var root;
    var curIndex = PlacesOrganizer._content.currentIndex;
    var rootIndex = -1;
    if (curIndex>-1 && PlacesOrganizer._content.view.isContainer(curIndex))
      rootIndex = curIndex;
    else if (curIndex>-1)
      rootIndex = PlacesOrganizer._content.view.getParentIndex(curIndex);;
    dump("current: "+curIndex+" | root: "+rootIndex+"\n");
    if (rootIndex>-1)
      root = PlacesOrganizer._content.getResultView().nodeForTreeIndex(rootIndex);
    else
      root = PlacesOrganizer._content.getResultNode();
    dump("root node: "+root+"\n");
    dump("root uri: "+root.uri+"\n");
    return root;
  },
  _loadImage : function(aURL){
    var nopreview = "chrome://bookmarkpreviews/skin/nopreview.png";
    var folderImage = "chrome://bookmarkpreviews/skin/folder.png";
    var file = this.dir.clone();
    file.append(encodeURIComponent(aURL.toLowerCase())+".jpg");
    if (file.exists() && file.isFile()){
      var contentType = Components.classes["@mozilla.org/mime;1"]
                              .getService(Components.interfaces.nsIMIMEService)
                              .getTypeFromFile(file);
      var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                                  .createInstance(Components.interfaces.nsIFileInputStream);
      inputStream.init(file, 0x01, 0600, 0);
      var stream = Components.classes["@mozilla.org/binaryinputstream;1"]
                             .createInstance(Components.interfaces.nsIBinaryInputStream);
      stream.setInputStream(inputStream);
      var encoded = btoa(stream.readBytes(stream.available()));
      return "data:" + contentType + ";base64," + encoded;
    }
    return nopreview;
  },
  getBookmarkImages : function(bkmks, aNode){
    if (!aNode)
      aNode = PlacesPreviewUtils.getViewRoot();
    var nsIResult = Components.interfaces.nsINavHistoryResultNode;
    var aS = Components.classes["@mozilla.org/browser/annotation-service;1"]
                    .getService(Components.interfaces.nsIAnnotationService);
    var cont = aNode.QueryInterface(Components.interfaces.nsINavHistoryContainerResultNode);
    var preOpened = cont.containerOpen;
    cont.containerOpen = true;
    var max = cont.childCount;
    for (var i = 0; i<max;i++){
      var node = cont.getChild(i);
      if (node.type == nsIResult.RESULT_TYPE_URI){
        var uri = node.uri;
        var title = node.title?node.title:node.uri;
        var image = PlacesPreviewUtils._loadImage(uri);
        bkmks.push({caption: title, url: uri, image: image, node: node});
      }else if (node.type!=nsIResult.RESULT_TYPE_SEPARATOR){
        bkmks.push({image: "chrome://bookmarkpreviews/skin/folder.png",
                   caption: node.title,
                   url: node.uri,
                   node: node});
      }
    }
    cont = preOpened;
  }
}
var AlbumViewUtils = {
  displayView : null,
  displayRoot : null,
  placesTree : null,
  bkmksTree : null,
  view : null,
  initDisplay : function(){
    AlbumViewUtils.displayView = AlbumView;
    AlbumView.init();
    TreeObserver.utils =AlbumViewUtils;
    AlbumViewUtils.placesTree = PlacesOrganizer._places;
    AlbumViewUtils.bkmksTree = PlacesOrganizer._content;
    AlbumViewUtils.view = AlbumViewUtils.bkmksTree.view;
    setTimeout(AlbumViewUtils.refreshDisplay,0);
  },
  uninit : function(){

  },
  _findNodeWithURI : function(root,uri){
    if (root.uri == uri) return root;
    for (var i=0;i<root.childCount;i++){
      var child = root.getChild(i);
      if (child.uri == uri)
        return child;
      if (child instanceof Components.interfaces.nsINavHistoryContainerResultNode){
        child=child.QueryInterface(Components.interfaces.nsINavHistoryContainerResultNode);
        if (child.containerOpen){
          if ((child = AlbumViewUtils._findNodeWithURI(child,uri)))
            return child;
        }
      }
    }
    return null;
  },
  refreshDisplay : function(event){
    var root;
    //AlbumViewUtils.view = AlbumViewUtils.bkmksTree.view;
    var curIndex = AlbumViewUtils.bkmksTree.currentIndex;
    var rootIndex = -1;
    if (curIndex>-1 && AlbumViewUtils.view.isContainer(curIndex))
      rootIndex = curIndex;
    else if (curIndex>-1)
      rootIndex = AlbumViewUtils.view.getParentIndex(curIndex);;
    if (rootIndex>-1)
      root = AlbumViewUtils.bkmksTree.getResultView().nodeForTreeIndex(rootIndex);
    else
      root = AlbumViewUtils.bkmksTree.getResultNode();

    if (root!=AlbumViewUtils.displayRoot){
      var bkmks=[]
      PlacesPreviewUtils.getBookmarkImages(bkmks,root);
      if (bkmks.length<100){
        AlbumView.createImages(bkmks);
        AlbumView.current = AlbumView.target = 0;
      }
    }
    var nextTarget=AlbumViewUtils._getNextTarget(curIndex,rootIndex);
    //dump("nexttarget: "+nextTarget+"\n");
    AlbumViewUtils.displayRoot = root;
    AlbumView.keepFocus = false;
    AlbumView.refresh();
    if (!(curIndex>-1 && AlbumViewUtils.view.isSeparator(curIndex)))
      AlbumView.glideTo(nextTarget*-150,false);
  },
  _getNextTarget : function(cIndex,rIndex){
    if (cIndex>rIndex+1){
      var max = AlbumViewUtils.view.rowCount, level = AlbumViewUtils.view.getLevel(cIndex);
      var nextTarget = 0;//rIndex==-1?-1:0;
      for (var i = rIndex+1;i<cIndex;i++){
        if (AlbumViewUtils.view.getLevel(i)==level &&
           !AlbumViewUtils.view.isSeparator(i))
          nextTarget++;
      }
      return nextTarget;
    }
    return 0;
  },
  selectIndex : function(node){
    AlbumViewUtils.updatedSelection = true;
    if (!(AlbumViewUtils.bkmksTree.hasSelection &&
        AlbumViewUtils.bkmksTree.hasSingleSelection &&
        AlbumViewUtils.bkmksTree.selectedNode == node)){
      AlbumViewUtils.view.selection.clearSelection();
      try{
      //AlbumViewUtils.selectNode(AlbumViewUtils.bkmksTree,node);
      AlbumViewUtils.bkmksTree.selectItems([node.itemId]);
      }catch(e){Components.utils.reportError(e);}
    }
    AlbumViewUtils.updatedSelection = false;
  },
  performAction : function(node, event){
    if (PlacesUtils.nodeIsBookmark(node)){
      openUILink(node.uri,event);
    }
    else if (PlacesUtils.nodeIsContainer(node)){
      //AlbumViewUtils.selectNode(AlbumViewUtils.placesTree,node);
      AlbumViewUtils.placesTree.selectItems([node.itemId]);
      //AlbumViewUtils.selectPlaceURI(AlbumViewUtils.placesTree,node.uri);
      //AlbumViewUtils.placesTree.selectPlaceURI(node.uri);
      //PlacesOrganizer.location = node.uri;
      //PlacesUtils.openContainerNodeInTabs(node, event);
      AlbumViewUtils.refreshDisplay();
    }
  }
}
var TreeObserver = {
  utils : null,
  canDrop : function(index, orientation){},
  onDrop : function(row, orientation){},
  onToggleOpenState  : function(index){},
  onCycleHeader : function(column){},
  onCycleCell : function(row, column){},
  onSelectionChanged : function(event){
    if (TreeObserver.utils.bkmksTree &&
        TreeObserver.utils.bkmksTree.view!=TreeObserver.utils.view){
      TreeObserver.utils.view = TreeObserver.utils.bkmksTree.view;
    }
    //dump("selection changed - "+AlbumView.updatedSelection+" - \n");
    if (!TreeObserver.utils.updatedSelection){
      /*
      This listens to the detailed view and the folder view.
      Although the selection of the detailed view is updated in time when
      this is sent from the detailed view's tree, it isn't updated
      in time when it is sent from a selection change from the folder
      view
      */
      //AlbumViewUtils.refreshDisplay();
      setTimeout(function(){
        dump("selection changed - "+TreeObserver.utils.updatedSelection+" - \n");
        TreeObserver.utils.refreshDisplay();
      },5);
    }
  },
  onPerformAction : function(action){
    dump("performaction\n");
  },
  onPerformActionOnRow : function(action, row){},
  onPerformActionOnCell : function(action, row, column){}
}
var ThumbViewUtils = {
  displayRoot : null,
  displayView : null,
  placesTree : null,
  view : null,
  initDisplay : function(){
    ThumbViewUtils.displayView = ThumbView;
    ThumbViewUtils.placesTree = PlacesOrganizer._places;
    TreeObserver.utils = ThumbView.utils = ThumbViewUtils;
    ThumbView.init();
    ThumbView.container.buildContextMenu = function(aPopup){
      dump("buildcontextmenu!\n");
      return false;
    }
    ThumbView.container.destroyContextMenu = function(aPopup){
      dump("destroycontextmenu!\n");
      return false;
    }
  },
  refreshDisplay : function(event){
    dump("refresh thumb display\n");
    var bkmks=[];

    PlacesPreviewUtils.getBookmarkImages(bkmks);
    ThumbView.loadImages(bkmks);
  },
  back : function(){PlacesOrganizer.back();},
  forward : function(){PlacesOrganizer.forward();},
  getBookmarkImages : PlacesPreviewUtils.getBookmarkImages,
  _getNextTarget : function(cIndex,rIndex){
    if (cIndex>rIndex+1){
      var max = ThumbViewUtils.view.rowCount, level = ThumbViewUtils.view.getLevel(cIndex);
      var nextTarget = 0;//rIndex==-1?-1:0;
      for (var i = rIndex+1;i<cIndex;i++){
        if (ThumbViewUtils.view.getLevel(i)==level &&
           !ThumbViewUtils.view.isSeparator(i))
          nextTarget++;
      }
      return nextTarget;
    }
    return 0;
  },
  selectIndex : function(node){
    ThumbViewUtils.updatedSelection = true;
    ThumbViewUtils.bkmksTree.selectItems([node.itemId]);
    //ThumbViewUtils.selectNode(ThumbViewUtils.bkmksTree,node);
    ThumbViewUtils.updatedSelection = false;
  },
  selectItem : function(item, event){
    ThumbViewUtils.updatedSelection = true;
    if (gEditItemOverlay.itemId != -1) {
      var focusedElement = document.commandDispatcher.focusedElement;
      if ((focusedElement instanceof HTMLInputElement ||
           focusedElement instanceof HTMLTextAreaElement) &&
          /^editBMPanel.*/.test(focusedElement.parentNode.parentNode.id))
        focusedElement.blur();
    }

    var detailsDeck = document.getElementById("detailsDeck");
    if (item) {
      detailsDeck.selectedIndex = 1;
      var selectedNode = item.node;
      if (selectedNode.itemId != -1) {
        PlacesOrganizer._content.selectItems([selectedNode.itemId]);
        if (PlacesOrganizer._paneDisabled) {
          PlacesOrganizer._setDetailsFieldsDisabledState(false);
          PlacesOrganizer._paneDisabled = false;
        }

        gEditItemOverlay.initPanel(selectedNode.itemId,
                                   { hiddenRows: ["folderPicker"] });

        PlacesOrganizer._detectAndSetDetailsPaneMinimalState(selectedNode);
        ThumbViewUtils.updatedSelection = false;
        return;
      }
    }
    else {
      detailsDeck.selectedIndex = 0;
      var selectItemDesc = document.getElementById("selectItemDescription");
      var itemsCountLabel = document.getElementById("itemsCountText");
      var rowCount = ThumbView.bookmarks.length;
      if (rowCount == 0) {
        selectItemDesc.hidden = true;
        itemsCountLabel.value = PlacesUtils.getString("detailsPane.noItems");
      }
      else {
        selectItemDesc.hidden = false;
        if (rowCount == 1)
          itemsCountLabel.value = PlacesUtils.getString("detailsPane.oneItem");
        else {
          itemsCountLabel.value =
            PlacesUtils.getFormattedString("detailsPane.multipleItems",
                                           [rowCount]);
        }
      }
    }

    // Nothing to do if the pane was already disabled
    if (!PlacesOrganizer._paneDisabled) {
      gEditItemOverlay.uninitPanel();
      PlacesOrganizer._setDetailsFieldsDisabledState(true);
      PlacesOrganizer._paneDisabled = true;
    }
    ThumbViewUtils.updatedSelection = false;
  },
  performAction : function(item, event){
    var node = item.node;
    if (PlacesUtils.nodeIsBookmark(node)){
      openUILink(node.uri,event);
    }
    else if (PlacesUtils.nodeIsContainer(node)){
      //ThumbViewUtils.selectPlaceURI(PlacesOrganizer._places,node.uri);
      ThumbViewUtils.placesTree.selectItems([node.itemId]);
      dump("previous location: "+PlacesOrganizer.location+"\n");
      dump("back|forward: "+PlacesOrganizer._backHistory+"|"+PlacesOrganizer._forwardHistory+"\n");
      //PlacesOrganizer.location = node.uri;
    }
  },
  removeItem : function(item, event){
    var node = item.node;
    PlacesUtils.bookmarks.removeItem(node.itemId);
    ThumbViewUtils.refreshDisplay();
  }
}
window.addEventListener('load',PlacesPreviewUtils.init,false);
window.addEventListener('unload',PlacesPreviewUtils.uninit,false);
