var ThumbView = {
  utils : null,
  initiated : false,
  currentIndex: -1,
  PREVIEW_SIZES: [80,160,320],
  PREVIEW_WIDTH: 160,
  NOPREVIEW : "chrome://bookmarkpreviews/skin/nopreview.png",
  updatedSelection : false,
  selectedItem : null,
  container : null,
  parent : null,
  bookmarks : null,
  maxColCount : -1,
  colCount : -1,
  rowCount : -1,
  rows : null,
  init : function(){
    /* add listeners */
    ThumbView.container = document.getElementById("thumbnailView");
    ThumbView.container.addEventListener("keypress",ThumbView.handleKeypress,false);
    ThumbView.parent = ThumbView.container.parentNode;
    ThumbView.parent.addEventListener("DOMAttrModified",ThumbView.onResize,true);
    var grid = document.getElementById("thumbnailGrid");
    grid.addEventListener("click",ThumbView.selectItem,false);
    grid.addEventListener("dblclick",ThumbView.performAction,false);

    /* Load size from prefs */
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch("extensions.thumbnails.");
    var size = 1;
    if (prefs.prefHasUserValue("size"))
      size = prefs.getIntPref("size");
    document.getElementById('thumbsSize').removeAttribute("disabled");
    var thumbPopup = document.getElementById("thumbsSizePopup");
    thumbPopup.childNodes[size].setAttribute("checked","true");
    ThumbView.PREVIEW_WIDTH = ThumbView.PREVIEW_SIZES[size];

    /* create images */
    var bkmks = [];
    ThumbView.utils.getBookmarkImages(bkmks);
    ThumbView.loadImages(bkmks,false);
    ThumbView.initiated = true;
  },
  uninit : function(){
    ThumbView.initiated = false;
    ThumbView.container.removeEventListener("keypress",ThumbView.handleKeypress,false);
    ThumbView.parent.removeEventListener("DOMAttrModified",ThumbView.onResize,true);
    var grid = document.getElementById("thumbnailGrid");
    grid.removeEventListener("click",ThumbView.selectItem,false);
    grid.removeEventListener("dblclick",ThumbView.performAction,false);
    document.getElementById('thumbsSize').setAttribute("disabled","true");
  },
  changeSize : function(size){
    var self = ThumbView;
    if (self.PREVIEW_WIDTH != self.PREVIEW_SIZES[size]){
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
      prefs = prefs.getBranch("extensions.thumbnails.");
      prefs.setIntPref("size",size);
      self.PREVIEW_WIDTH = self.PREVIEW_SIZES[size];
      dump("change size loadimages: "+ThumbView.bookmarks+"\n");
      self.loadImages(ThumbView.bookmarks);
    }
  },
  onResize : function(event){
    if ((event.attrName=="width" ||
         event.attrName=="pageincrement")){
      var colCount = Math.floor(ThumbView.parent.boxObject.width / (ThumbView.PREVIEW_WIDTH+6));
      if (colCount != ThumbView.maxColCount && colCount > 0)
        dump("onresize: "+ThumbView.bookmarks+"\n");
        ThumbView.loadImages(ThumbView.bookmarks);
    }
  },
  loadImages : function(images, appendNodes){
    if (!images) return;
    //dump("load images - "+images!=null+"|"+images+"\n");
    ThumbView.bookmarks = images;
    var thumbDeck = ThumbView.parent;
    var maxWidth = thumbDeck.boxObject.width;
    var maxHeight = thumbDeck.boxObject.height;
    var colCount = Math.floor(maxWidth / (ThumbView.PREVIEW_WIDTH+6));
    this.maxColCount = colCount;
    var rowCount;
    if (colCount > images.length) {
      colCount = images.length;
      rowCount = 1;
    }
    else{
      rowCount = Math.ceil(images.length / colCount);
    }
    this.colCount = colCount;
    this.rowCount = rowCount;
    var grid = document.getElementById("thumbnailGrid");

    while (grid.lastChild)
      grid.removeChild(grid.lastChild);

    var cols = document.createElement("columns");
    for (var i = 0; i< colCount; i++){
      var col = document.createElement("column");
      cols.appendChild(col);
    }
    grid.appendChild(cols);

    var rows = document.createElement("rows");
    for (var rowIndex = 0; rowIndex < rowCount; rowIndex++){
      var row = document.createElement("row");
      for (var colIndex = 0; colIndex < colCount; colIndex++){
        var index = rowIndex * colCount + colIndex;
        if (index >= images.length)
          break;
        row.appendChild(ThumbView._createThumb(images[index]));
      }
      rows.appendChild(row);
    }
    ThumbView.rows = rows;
    grid.appendChild(rows);
    if (colIndex>0){
      var ele = rows.firstChild.firstChild;
      this.selectItem({target: ele, button: 0});
    }
    //this.setSize(grid, colCount * this.PREVIEW_WIDTH, maxHeight);
  },
  _createThumb : function(item){
    var box = document.createElement("vbox");
    box.setAttribute("pack","center");
    box.setAttribute("align","center");
    box.setAttribute("class","thumbnail");
    var imageEle = document.createElement("image");
    imageEle.setAttribute("src",item.image);
    //image.setAttribute("style","background-color: red");
    //image.setAttribute("width",320);
    var img = new Image();
    img.src = item.image;
    imageEle.setAttribute("width",this.PREVIEW_WIDTH);
    if (item.image!=ThumbView.NOPREVIEW){
      if (img.complete){
        imageEle.setAttribute("height",
              parseInt(img.height * ThumbView.PREVIEW_WIDTH / img.width));
        imageEle.setAttribute("maxHeight",imageEle.getAttribute("height"));
        //dump(item.node.title+"heightc: "+imageEle.getAttribute("height")+"\n");
      }else{
        img.onload = function(){
          //dump(item.node.title+"\nheightl: "+ parseInt(img.height * ThumbView.PREVIEW_WIDTH / img.width)+"\n");
          imageEle.setAttribute("height",
              parseInt(img.height * ThumbView.PREVIEW_WIDTH / img.width));
          /* re-insert so the row/box will refresh the layout
            otherwise the height gets stretched/not updated */
          var nextSibling = imageEle.parentNode.nextSibling;
          imageEle.parentNode.parentNode.insertBefore(imageEle.parentNode,nextSibling);
        }
      }
    }
    else
      imageEle.setAttribute("height",
                            200 * ThumbView.PREVIEW_WIDTH / 320);
    box.appendChild(imageEle);
    var desc = document.createElement("label");
    desc.setAttribute("value",item.caption);
    desc.setAttribute("crop","end");
    desc.setAttribute("class","thumbnail-label");
    desc.setAttribute("width",ThumbView.PREVIEW_WIDTH);
    desc.setAttribute("maxWidth",ThumbView.PREVIEW_WIDTH);
    desc.setAttribute("style","max-width: "+ThumbView.PREVIEW_WIDTH+"px;");
    box.appendChild(desc);
    box.setAttribute("tooltiptext",item.caption);
    imageEle.setAttribute("tooltiptext",item.caption);
    return box;
  },
  _getClickTarget : function(event){
    var target = event.target;
    if (target.className == "thumbnail")
      return target;
    else if (target.tagName == "image")
      return target.parentNode;
    return null;
  },
  copyEvent : function(event){
    var tEvt = {};
    for (var p in event){
      try{
        tEvt[p] = event[p];
      }catch(e){}
    }
    return tEvt;
  },
  handleKeypress : function(event){
    var KeyEvent = Components.interfaces.nsIDOMKeyEvent;
    var self = ThumbView;
    dump("keypress: "+event.keyCode+"|"+self.selectedItem+"\n");
    if (!self.selectedItem)
      return;
    try{
    switch(event.keyCode){
      case KeyEvent.DOM_VK_LEFT:
        if (event.altKey){
          ThumbViewUtils.back();
          event.preventDefault();
          event.stopPropagation();
          return;
        }
        var previous = self.selectedItem.previousSibling;
        if (!previous){
          previous = self.selectedItem.parentNode.lastChild;
        }
        var tEvt = {button: 0, target: previous};
        self.selectItem(tEvt);
        event.preventDefault();
        event.stopPropagation();
        break;
      case KeyEvent.DOM_VK_RIGHT:
        if (event.altKey){
          ThumbViewUtils.forward();
          event.preventDefault();
          event.stopPropagation();
          return;
        }
        var next = self.selectedItem.nextSibling;
        if (!next){
          next = self.selectedItem.parentNode.firstChild;
        }
        var tEvt = {button: 0, target: next};
        self.selectItem(tEvt);
        event.preventDefault();
        event.stopPropagation();
        break;
      case KeyEvent.DOM_VK_UP:
        var colIdx = self._findElementIndex(self.selectedItem);
        var rowIdx = self._findElementIndex(self.selectedItem.parentNode);
        var newRow = null;
        while (!newRow){
          rowIdx--;
          if (rowIdx<0) rowIdx = self.rowCount-1;
          if ((newRow = self.rows.childNodes[rowIdx]).length>colIdx)
            newRow = null;
        }
        if (newRow){
          var next = newRow.childNodes[colIdx];
          var tEvt = self.copyEvent(event);
          tEvt.target = tEvt.originalTarget = next;
          self.selectItem(tEvt);
        }
        event.preventDefault();
        event.stopPropagation();
        break;
      case KeyEvent.DOM_VK_DOWN:
        var colIdx = self._findElementIndex(self.selectedItem);
        var rowIdx = self._findElementIndex(self.selectedItem.parentNode);
        var newRow = null;
        while (!newRow){
          rowIdx++;
          if (rowIdx==self.rowCount) rowIdx = 0;
          if ((newRow = self.rows.childNodes[rowIdx]).length>colIdx)
            newRow = null;
        }
        if (newRow){
          var next = newRow.childNodes[colIdx];
          var tEvt = self.copyEvent(event);
          tEvt.target = tEvt.originalTarget = next;
          self.selectItem(tEvt);
        }
        event.preventDefault();
        event.stopPropagation();
        break;
      case KeyEvent.DOM_VK_RETURN:
      case KeyEvent.DOM_VK_ENTER:
        var tEvt = self.copyEvent(event);
        tEvt.target = tEvt.originalTarget = self.selectedItem;
        tEvt.button = 1;
        self.performAction(tEvt);
        event.preventDefault();
        event.stopPropagation();
        break;
      case KeyEvent.DOM_VK_DELETE:
        var rowIndex = self._findElementIndex(self.selectedItem.parentNode);
        var colIndex = self._findElementIndex(self.selectedItem);
        var index = rowIndex * self.colCount + colIndex;
        ThumbViewUtils.removeItem(ThumbView.bookmarks[index]);
        event.preventDefault();
        event.stopPropagation();
        break;
    }
    }catch(e){Components.utils.reportError(e);}
  },
  selectedNode : function(){
    var self = ThumbView, target = self.selectedItem;
    var rowIndex = self._findElementIndex(target.parentNode);
    var colIndex = self._findElementIndex(target);
    var index = rowIndex * self.colCount + colIndex;
    return self.bookmarks[index].node;
  },
  selectItem : function(event){
    dump("selectitem: "+event.button+"\n");
    if (event.button == 1){
      /* middle click should open it in tabs */
      ThumbView.performAction(event);
      return;
    }
    var self = ThumbView;
    var target = self._getClickTarget(event);
    if (!target) return;
    if (self.selectedItem!=null){
      self.selectedItem.removeAttribute("selected");
    }
    self.selectedItem = target;
    if (target){
      self.selectedItem.setAttribute("selected","true");
      var nsIScroll = ThumbView.container.boxObject.QueryInterface(
                        Components.interfaces.nsIScrollBoxObject);
      nsIScroll.ensureElementIsVisible(self.selectedItem);
      var rowIndex = self._findElementIndex(target.parentNode);
      var colIndex = self._findElementIndex(target);
      var index = rowIndex * self.colCount + colIndex;
      ThumbViewUtils.selectItem(ThumbView.bookmarks[index],event);
    }
    else{
      ThumbViewUtils.selectItem(null,event);
    }
  },
  _findElementIndex : function(ele){
    var nodes = ele.parentNode.childNodes;
    for (var i = 0;i<nodes.length;i++){
      if (nodes[i]==ele){
        return i;
      }
    }
    return -1;
  },
  performAction : function(event){
    if (event.button==2) return;
    var self = ThumbView;
    var target = self._getClickTarget(event);
    dump("performAction target: "+target+"\n");
    if (target){
      var rowIndex = self._findElementIndex(target.parentNode);
      var colIndex = self._findElementIndex(target);
      var index = rowIndex * self.colCount + colIndex;
      ThumbViewUtils.performAction(ThumbView.bookmarks[index],event);
    }
  },
  setSize: function(ele,width,height){
    ele.setAttribute("height",height);
    ele.setAttribute("width",width);
    ele.setAttribute("flex", 0);

    ele.style.height = height + "px";
    ele.style.minHeight = ele.style.height;
    ele.style.maxHeight = ele.style.height;

    ele.style.width = width + "px";
    ele.style.minWidth = ele.style.width;
    ele.style.maxWidth = ele.style.width;
  }
}
